#pragma once

#include "CoreMinimal.h"
#include "SurvivorStatusInterface.h"
#include "CurseAbilitySurvivorComponent.h"
#include "Templates/SubclassOf.h"
#include "EHealthState.h"
#include "K41CurseAbilitySurvivorComponent.generated.h"

class UStatusEffect;
class UFloatValueStrategy;
class UAkAudioEvent;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class UK41CurseAbilitySurvivorComponent : public UCurseAbilitySurvivorComponent, public ISurvivorStatusInterface
{
	GENERATED_BODY()

private:
	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	UStatusEffect* _doomedBrokenStatusEffectInstance;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _doomedBrokenStatusEffectClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced, meta=(AllowPrivateAccess=true))
	UFloatValueStrategy* _minValueForCurseAmountRemovedByMushroom;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	UAkAudioEvent* _mushroomEffectStartAkEvent;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	UAkAudioEvent* _mushroomEffectStopAkEvent;

public:
	UFUNCTION(BlueprintPure)
	bool IsDoomed() const;

	UFUNCTION(BlueprintPure)
	bool IsDamned() const;

private:
	UFUNCTION(BlueprintCallable)
	void Authority_OnSurvivorHealthStateChanged(EHealthState oldDamageState, EHealthState newDamageState);

public:
	UK41CurseAbilitySurvivorComponent();
};

FORCEINLINE uint32 GetTypeHash(const UK41CurseAbilitySurvivorComponent) { return 0; }
